//******************************************************************************
// fric.java:	class na obsluhu okna s obrazkom
//
//******************************************************************************

import java.applet.*;
import java.awt.*;
import java.awt.image.*;


//==============================================================================
// Class fric
//
//==============================================================================
public class fric extends Frame
{


	int imageWidth;			// sirka obrazku
	int imageHeight;		// vyska obrazku
	final int imgShiftX = 10;			// posun obrazku v okne od laveho okraja
	final int imgShiftY = 30;			// posun obrazku v okne od horneho okraja

	int x1, y1, x2, y2;
		
	frsc fs;				// referencia na nadradenu triedu frsc

	Image img;				// obrazok
	int imgBuf[]; 				// buffer obrazku

	
	// konstruktor fric
    //--------------------------------------------------------------------------
	public fric(frsc fs_, int imageWidth,int imageHeight)
	{
		fs = fs_;
		this.imageWidth = imageWidth;
		this.imageHeight = imageHeight;
		imgBuf = new int[imageWidth*imageHeight];	// buffer obrazku
		reshape(295,70,imageWidth+20,imageHeight+60);
		setTitle("Biomorph - image");
		show();
	}

	// Paint Handler
	//--------------------------------------------------------------------------
	public void paint(Graphics g)
	{
	
		g.drawImage(img, imgShiftX, imgShiftY, this);
		if(x1!=x2)
		{
			g.setColor(Color.red);
			g.drawRect(x1, y1, x2-x1, y2-y1);
		}
		
	}
	
	
	
	// MOUSE SUPPORT:
	//		The mouseDown() method is called if the mouse button is pressed
	// while the mouse cursor is over the applet's portion of the screen.
	//--------------------------------------------------------------------------
	public boolean mouseDown(Event evt, int x, int y)
	{
		x2=x1=x;
		y2=y1=y;
		return true;
	}

	// MOUSE SUPPORT:
	//		The mouseUp() method is called if the mouse button is released
	// while the mouse cursor is over the applet's portion of the screen.
	//--------------------------------------------------------------------------
	public boolean mouseUp(Event evt, int x, int y)
	{	
		if(fs.counting == false){
			fs.novyVyrez(x1-imgShiftX, x2-imgShiftX, imageHeight-(y2-imgShiftY)-1);
			return true;
		}
		return false;
	}

	// MOUSE SUPPORT:
	//		The mouseDrag() method is called if the mouse cursor moves over the
	// applet's portion of the screen while the mouse button is being held down.
	//--------------------------------------------------------------------------
	public boolean mouseDrag(Event evt, int x, int y)
	{	
		if(fs.counting == false){
			y2=y;
			x2=x1+(y2-y1)*imageWidth/imageHeight;
			repaint();
			return true;
		}
		return false;
	}

		
	// "zrusenie" oznaceneho vyrezu
	//--------------------------------------------------------------------------
	private void resetRectangle()
	{
		x1=x2=0;
	}
	
	
	// predefinovana metoda redraw
	//--------------------------------------------------------------------------
	public void redraw()
	{
		img=createImage(new MemoryImageSource(imageWidth,imageHeight,imgBuf,0,imageWidth));
		resetRectangle();
		repaint();
	}
	
	
	// urcenie realnej farby bodu
	//--------------------------------------------------------------------------
	public int makeColor(int b)
	{
		if(b==0) return Color.black.getRGB();
		else{
			if(fs.nOfColors == 2) {
				return Color.white.getRGB();
			}
			else return fs.akt[b-1].getRGB();
		}
	}
	
		
	// vlozenie bodu do buffera obrazku
	//--------------------------------------------------------------------------
	public void point(int x, int y, int b)
	{
		imgBuf[x+(imageHeight-1-y)*imageWidth]= makeColor(b);
	}
	

	// vypocet hodnoty "step" = rozmer pixelu v obrazku
	//--------------------------------------------------------------------------
	public double stepValue(suradnice s)
	{
		return (s.r1-s.r0)/imageWidth;
	}
	
	
	// vypocet hornej hranice na imaginarnej osi
	// (vyrata sa tak, aby bol obrazec nezdeformovany)
	//--------------------------------------------------------------------------
	public double i1Value(suradnice s)
	{
		return s.i0+imageHeight*stepValue(s);		
	}

}
